// ROOT script for  automatic documentation
// $Id: loadlibs.C,v 1.14 2006/02/03 17:46:29 naumov Exp $
// A.Thea, D.Naumov created Jun 17 2004
// loadlibs: loads libraries needed by ESAF documents generation

void loadlibs()
{
    // ROOT libs
    cout << "Loading ROOT libraries: \n" << flush;
    cout << "        ";
    gSystem->Load("libPhysics");    cout << "Physics, ";
    gSystem->Load("libGeom");       cout << "Geom, ";
//    gSystem->Load("libMinuit");
//     gSystem->Load("libGui");
    gSystem->Load("libGed");        cout << "Ged.\n";
    // common libs
    cout << "Loading ESAF libraries: \n" << flush;
    cout << "        ";

    gSystem->Load("libbase.so");              cout << "base, ";
    gSystem->Load("libSimuEvent.so");         cout << "SimuEvent, ";
    gSystem->Load("libgui.so");               cout << "gui, ";

    // Simu libs
    gSystem->Load("libtools.so");             cout << "tools, ";
    gSystem->Load("libelectronics.so");       cout << "electronics, ";
    gSystem->Load("liboptics.so");            cout << "optics, ";
    gSystem->Load("libatmosphere.so");        cout << "atmosphere, ";
    gSystem->Load("libgenbase.so");           cout << "genbase, ";
    gSystem->Load("libshowers.so");           cout << "showers, ";
    gSystem->Load("liblightsources.so");      cout << "lightsources, ";
    gSystem->Load("libsimuframework.so");     cout << "simuframework, ";
    gSystem->Load("liblowtran.so");           cout << "lowtran, ";
    gSystem->Load("libcfortran.so");          cout << "cfortran, \n";
    cout << "        ";
    gSystem->Load("libslast.so");             cout << "slast, ";
    gSystem->Load("libradiativetransfer.so"); cout << "radiativetransfer, ";
    gSystem->Load("liblighttoeuso.so");       cout << "lighttoeuso, ";
    gSystem->Load("libdettools.so");          cout << "dettools, ";

    // Reco libs
    gSystem->Load("libRecoRootEvent.so"); cout << "RecoRootEvent, ";
    gSystem->Load("libRecoViewer.so");    cout << "RecoViewer, ";
    gSystem->Load("librecoframework.so"); cout << "recoframework, ";
    gSystem->Load("libevent.so");         cout << "event, ";
    gSystem->Load("libinput.so");         cout << "input, ";
    gSystem->Load("liboutput.so");        cout << "output, ";
    gSystem->Load("libclustering.so");    cout << "clustering, \n";
    cout << "        ";
    gSystem->Load("libenergy.so");        cout << "energy, ";
    gSystem->Load("libfitting.so");       cout << "fitting, ";
    gSystem->Load("libfootprint.so");     cout << "footprint, ";
    gSystem->Load("libmass.so");          cout << "mass, ";
    gSystem->Load("libmeteorites.so");    cout << "meteorites, ";
    gSystem->Load("libneutrino.so");      cout << "neutrino, ";
    gSystem->Load("libprofile.so");       cout << "profile, ";
    gSystem->Load("libtruth.so");         cout << "truth, ";

    // Event View libs
    gSystem->Load("libEventViewer.so");   cout << "EventViewer.\n";

}
