void MultiEventAnalysis (){
 
  gROOT->Reset();
  TChain *chain = new TChain("etree");
  FILE *CHFILE;
  //reading ListOfFiles and moving to the output dir
  CHFILE = fopen("ListOfFiles","r");
  TString workDir = gSystem->WorkingDirectory(); 
  gSystem->ChangeDirectory(gEusoOutputDirectory);
  char RootFileName[250];
  cout << "The following files are to be analized "  << endl;
  Int_t Nfiles=0;
  while((fgets(RootFileName,sizeof(RootFileName),CHFILE)) !=NULL)
    {
      Nfiles +=1;
      char root_file_name[250];
      sscanf(RootFileName,"%s",root_file_name);
      chain->Add(root_file_name);
      cout << Nfiles << ".) " << root_file_name << endl; 
    }
  cout << "Starting Multi Events Analysis " ; 
  GlobalHisto t(chain);
  t.SetXVariable("Energy");
  DoAndSaveAll(&t);
  t.SetXVariable("Theta");
  DoAndSaveAll(&t);
  gSystem->ChangeDirectory(workDir);
  cout << "done" << endl;
  cout << " " << endl;
}

void DoAndSaveAll(GlobalHisto* t){
    TCanvas *c1;
    if (!(c1 = (TCanvas *)gROOT->GetListOfCanvases()->FindObject("c1")))
	c1 = new TCanvas();
    c1->cd();
    c1->Clear();
    TH1* thist;
    hist = t->Do1DNumPhotons();
    SavePlot(hist, hist->GetName());
    hist = t->Do1DX();
    SavePlot(hist, hist->GetName());
    hist = t->Do1DDetectedPhotonsFromChip();
    SavePlot(hist, hist->GetName());
    hist = t->Do1DDetectedPhotonsFromMacrocells();
    SavePlot(hist, hist->GetName());
    hist = t->Do1DPhotonsLostInOptics();
    SavePlot(hist, hist->GetName());
    hist = t->Do1DPhotonsLostOnFocalPlane();
    SavePlot(hist, hist->GetName());
    hist = t->Do1DHitPixels();
    SavePlot(hist, hist->GetName());
    hist = t->Do1DHitMacroCells();
    SavePlot(hist, hist->GetName());
    hist = t->Do1DNumOfFee();
    SavePlot(hist, hist->GetName());
    hist = t->Do1DNumOfAFee();
    SavePlot(hist, hist->GetName());
    hist = t->Do1DTriggerVsX();
    SavePlot(hist, hist->GetName());
    hist = t->Do2DDetectedPhotonsVsX();
    SavePlot(hist, hist->GetName());
    hist = t->Do2DAveragePhotonVsX();
    SavePlot(hist, hist->GetName());
    hist = t->Do2DXCorrelation();
    SavePlot(hist, hist->GetName());
}

void SavePlot(TH1 *obj, TString name, TString opt="")
{
    TCanvas *display;
    if (!(display = (TCanvas *)gROOT->GetListOfCanvases()->FindObject("c1")))
	display = new TCanvas();
    display->cd(1);
    if (opt.CompareTo(""))
	obj->Draw(opt);
    else
	obj->Draw();
    display->Modified();
    display->Update();
    display->Print("gif/"+name+".gif");
    display->Print("eps/"+name+".eps");
}
