// $Id: AtmosphereFactory.hh,v 1.14 2005/01/13 15:20:27 moreggia Exp $
// Sylvain Moreggia created Dec,  1 2003

#ifndef __ATMOSPHEREFACTORY_HH_
#define __ATMOSPHEREFACTORY_HH_

/*****************************************************************************
 * ESAF: Euso Simulation and Analysis Framework                              *
 *                                                                           *
 *  Id: AtmosphereFactory                                                    *
 *  Package: atmosphere                                                      *
 *  Coordinator: S. Moreggia                                                 *
 *                                                                           *
 *****************************************************************************/

///////////////////////////////////////////////////////////////////////////////////
// AtmosphereFactory                                                             //
//                                                                               //
// Builds atmosphere related objects according to config files                   //
// Does not build Atmosphere object itself, even if it appears in config files   //
//                                                                               //
///////////////////////////////////////////////////////////////////////////////////

#include "euso.hh"
#include "EsafConfigurable.hh"
#include "Atmosphere.hh"
#include "EsafMsgSource.hh"



class Clouds;

class AtmosphereFactory : public EsafConfigurable, public EsafMsgSource {
public:
    
    // dtor
    virtual ~AtmosphereFactory();

    // instance 
    static AtmosphereFactory *Get();
    
    // Build clouds object
    Clouds* GetClouds();
        
    EsafConfigClass(Atmosphere,AtmosphereFactory)
 
private:
    // ctor
    AtmosphereFactory();

    // unique instance of AtmosphereFactory
    static AtmosphereFactory *fMe;
    

    ClassDef(AtmosphereFactory,0)
};

#endif  /* __ATMOSPHEREFACTORY_HH_ */

