// ESAF : Euso Simulation and Analysis Framework
// $Id: EVector.hh,v 1.5 2004/09/13 21:46:09 thea Exp $
// Daniel De Marco created Apr,  2 2002

#ifndef __EVECTOR_HH_
#define __EVECTOR_HH_

#include <iostream>
#include "euso.hh"
#include "TVector3.h"

class EarthVector;

class EVector : public TVector3 {
public:
    EVector(Double_t x = 0.0, Double_t y = 0.0, Double_t z = 0.0): TVector3(x,y,z) {}
    EVector(const Double_t* d): TVector3(d) {}
    EVector(const Float_t* f): TVector3(f) {}
    EVector(const EVector& e): TVector3(e) {}
    EVector(const EarthVector&);
    virtual ~EVector() {}
    EVector(const TVector3 &v): TVector3(v) {}
    friend ostream& operator<<(ostream &os, const EVector &v);

    ClassDef(EVector,0)
};

#endif  /* __EVECTOR_HH_ */

