// $Id: EsafRandom.hh,v 1.5 2005/07/22 10:50:53 thea Exp $
// M.Pallavicini created Feb, 11 2002

/*****************************************************************************
 * ESAF: Euso Simulation and Analysis Framework                              *
 *                                                                           *
 *  Id: EsafRandom                                                           *
 *  Package: Base                                                            *
 *  Coordinator: Marco.Pallavicini                                           *
 *                                                                           *
 *****************************************************************************/


#ifndef __EUSORANDOM_HH_
#define __EUSORANDOM_HH_

#include "euso.hh"
#include "EsafConfigurable.hh"
#include "EsafMsgSource.hh"
#include "TRandom2.h"
#include "TRandom3.h"

////////////////////////////////////////////////////////////////////////////////
//                                                                            //
// EsafRandom                                                                 //
//                                                                            //
// Esaf random numbers generators manager                                     //
//                                                                            //
////////////////////////////////////////////////////////////////////////////////

class EsafRandom : public EsafConfigurable, public EsafMsgSource {
public:
    virtual ~EsafRandom();
    
    static TRandom* Get();

    inline TRandom* GetRandom() { return fRndm; }

    EsafConfigClass(General,EsafRandom)

private:
    EsafRandom();
    static EsafRandom *fgMe;
    TRandom *fRndm;
    ClassDef(EsafRandom,0)
};

#endif  /* __EUSORANDOM_HH_ */

