// utils
// $Id: utils.hh,v 1.4 2004/12/22 16:17:52 thea Exp $
//
// miscellaneous utilities
//
#ifndef __UTILS_HH_
#define __UTILS_HH_

#include <stdexcept>
#include <string>
#include <algorithm>
#include "euso.hh"
#include <iostream>

inline string &swallow_spaces(string &s) {
        return s.erase(0, s.find_first_not_of("\t "));
}

inline string &r_swallow_spaces(string &s) {
        return s.erase(s.find_last_not_of("\t ")+1, string::npos);
}
                
inline double toDouble(const string &s) {
        // trying for a double
        char *p;
        double d=strtod(s.c_str(), &p);
        if(d==0 && s.c_str()==p) // not a double
               return strtod("NaN",0);
        if(s.c_str()+s.size()!=p) // not a double
               return strtod("NaN",0);
        return d;
}

// solve a x^2 + b x + c = 0 keeping attention to roundoff
// The result is a pair<int, double*>
// the first component of the pair is the number of solutions
// while the second one is an double[2] array containing the solutions.
pair<int, double*> &findRoots(double a, double b, double c);
inline int sign(double d) { return (d>0?1:-1); }

// find root of 1d function f(x) = 0 between two points x1 and x2
// adapted from Numerical Recipes in C. Chapter 9. Root Finding and 
// Nonlinear Sets of Equations
// by Dmitry V. Naumov 04/07/2004

#define FACTOR 1.6
#define NTRY 50
#define JMAX 40
int zbrac(float (*func)(float), float *x1, float *x2);
float rtbis(float (*func)(float), float x1, float x2, float xacc);
void write_counter(char*,double,double);
#endif /* __UTILS_HH_ */
