// ESAF : Euso Simulation and Analysis Framework
// $Id: EsafMsg.cc,v 1.9 2006/03/14 01:10:20 thea Exp $
// M. Pallavicini created Sep, 24 2004
// ESAF Message 
// 

#include "EsafMsg.hh"
#include "EsafMsgDispatcher.hh"

//______________________________________________________________________________
//
//  ESAF message
//  ============
//
//  See EsafMsgSource for details
//


ClassImp(EsafMsg)	

//______________________________________________________________________________
EsafMsg::EsafMsg() : ostringstream("") {
    // 
	// empty ctor
	// set message values to default
    // 

    exceptions(std::ios_base::badbit);
	fSender = "None";
	fSeverity = EsafMsg::None;
	fProgress = -1;
}

//______________________________________________________________________________
EsafMsg::EsafMsg(const EsafMsg& o ) {
    //
    // Copy constructor
    // 

    o.Copy(*this); 
}

//______________________________________________________________________________
EsafMsg::EsafMsg(EsafMsg::MsgSeverity svr, const string& snd, const string& txt) : ostringstream(txt) {
    // 
	// ctor
    //
	
	fSender = snd;
	fSeverity = svr;
	fProgress = -1;
}

//______________________________________________________________________________
EsafMsg::~EsafMsg() {
    // 
	// dtor
    //
}

//______________________________________________________________________________
void EsafMsg::Copy( EsafMsg& o ) const {
    //
    // Copy this to o
    // 
    
    o.fSeverity = fSeverity;
    o.fSender   = fSender;
    o.fProgress = fProgress;
    o.str(str());
}
//______________________________________________________________________________
EsafMsg& EsafMsg::operator=(const EsafMsg& o ) {
    //
    //
    //
    
    o.Copy(*this);
    return *this;
}

//______________________________________________________________________________
void EsafMsg::Clear() {
    // 
	// clear message
    //
	
	fSeverity = EsafMsg::None;
	str("");
	fProgress = -1;
	
}
	
//______________________________________________________________________________
void EsafMsg::Dispatch() {
    // 
	// Dispatch message
    // 

	EsafMsgDispatcher::Get()->Dispatch( *this );
    Clear();
	
}

//______________________________________________________________________________
void EsafMsg::Flush() {
    // 
	// Dispatch message
    // 

	EsafMsgDispatcher::Get()->Dispatch( *this, kFALSE);
    Clear();
	
}

//______________________________________________________________________________
void EsafMsg::Count() {
    //
    // Counting progress
    //

    EsafMsgDispatcher::Get()->Dispatch( *this, kFALSE, kTRUE);
    Clear();
}
