// ESAF : Euso Simulation and Analysis Framework
// $Id: EShowerHistoPainter.hh,v 1.3 2005/01/18 16:52:09 moreggia Exp $
// Author: Naumov Dmitry   Jul, 26 2004

#ifndef __ESHOWERHISTOPAINTER_HH__
#define __ESHOWERHISTOPAINTER_HH__

//#include "euso.hh"
#include "EAnimator.hh"
#include "TSeqCollection.h"

class EShower;
class TH1F;
class TTimer;

/*******************************************************************************
 *
 * EShowerHistoPainter: this class plots and animates a set of standard
 * histograms describing the shower development.
 *
 ******************************************************************************/

class EShowerHistoPainter : public EAnimator {
public:
    EShowerHistoPainter( EShower* );
    virtual ~EShowerHistoPainter();

    virtual void Draw(Option_t *opt="");

    void Build();

    virtual void NextFrame();

    TH1F* GetTimeHisto(const char*, const char* =0);
    TH1F* GetAltHisto(const char*, const char* =0); //NEW

    TSeqCollection* GetListOfHistos() {return fHistos;}

private:

    void UpdateHistos();

    TSeqCollection *fHistos;

    EShower         *fShower;
    Double_t        *fTimeBins;
    Double_t        *fAltBins; //NEW
    Double_t        fNeMax;
    Double_t        fAgeMax;
    Double_t        fDepthMax;

    ClassDef(EShowerHistoPainter,1);
};

#endif  /* __ESHOWERHISTOPAINTER_HH__ */

