// DetectorConfigDlg.hh
//
#ifndef __DETECTORCONFIGDLG_HH_
#define __DETECTORCONFIGDLG_HH_

#include "TGFrame.h"
#include "TGButton.h"
#include "TGTab.h"
#include "TGNumberEntry.h"
#include "TGComboBox.h"

class SimuApplication;

class DetectorConfigDlg : public TGTransientFrame {
public:
    DetectorConfigDlg(SimuApplication*,const TGWindow*,const TGWindow*);
    ~DetectorConfigDlg();

    virtual void CloseWindow();
    virtual Bool_t ProcessMessage( Long_t, Long_t, Long_t );

private:
    void RetrieveData();               // get data from widgets and update config

    SimuApplication *theApp;
    TGCompositeFrame *fFrame;
    TGButton *fOK,*fCancel;
    TGTab *fTab;
    TGLayoutHints *fL1, *fL2, *fL3, *fL4, *fL5, *fL6;
    TGCompositeFrame *fStandard, *fEnvironment, *fOptics, *fAdaptors, *fPmts, *fEle, *fTrigg;

    // objects for Standard TAB
    TGComboBox *fStandardListBox;

    TGButton *fChkNG, *fChkSIG;
    TGGroupFrame *fNightGlow;
    TGNumberEntry *fRateNG;

    ClassDef(DetectorConfigDlg,0)
};

#endif
