// $Id: ShowHistoDlg.hh,v 1.5 2005/10/18 23:17:30 thea Exp $
// ShowHistoDlg.hh
// M. Pallavicini - created 18/4/03
// Window to handle standard event histograms
// 
#ifndef __SHOWHISTODLG_HH_
#define __SHOWHISTODLG_HH_

#include "TGFrame.h"
#include "TGButton.h"
#include "TGTab.h"
#include "TGNumberEntry.h"
#include "TGComboBox.h"
#include "TGMenu.h"
#include "TGCanvas.h"
#include "TRootEmbeddedCanvas.h"

class SimuApplication;
class TTree;

enum EusoStandardHistos {
    H_PHOTON_1,           // canvas with photon history
    H_PHOTON_PHCOSTH_1,   // focal surface plot
    H_PHOTON_XY_1,        // xy plot
    H_PHOTON_WLXY_1,      // wavelenghts xy plot
    H_TRIGGER_EFF_1       // canvas with trigger efficiency 
};

class ShowHistoDlg : public TGTransientFrame {
public:
    ShowHistoDlg(SimuApplication*,const TGWindow*,const TGWindow*, TTree* tree=0);
    ~ShowHistoDlg();

    virtual void CloseWindow();
    virtual Bool_t ProcessMessage( Long_t, Long_t, Long_t );

private:
    void HandleMenuCommand( Long_t );
    SimuApplication *theApp;
    TTree *theTree;
    TGCompositeFrame *fFrame, *fDisplayFrame;
    TGButton *fOK,*fCancel;
    TGLayoutHints *fL1, *fL2, *fL5, *fL7;
    TGLayoutHints *fMenuLayout, *fItemLayout; 
    TGMenuBar *fMenu;          // menu bar of the main window
    TGPopupMenu *fMenuHisto, *fMenuHistoGlobal, *fMenuOptions;
    TRootEmbeddedCanvas *fEmbeddedCanvas;
    TCanvas *fCanvas;

    ClassDef(ShowHistoDlg,0)
};

#endif
