// ESAF : Euso Simulation and Analysis Framework
// $Id: TestRecoModule.cc,v 1.7 2006/03/28 09:13:43 thea Exp $
// Marco Pallavicini created Oct, 16 2003

#include <iostream>
#include "TestRecoModule.hh"

ClassImp(TestRecoModule)

//______________________________________________________________________________
TestRecoModule::TestRecoModule(const string& n) : RecoModule(n) {
    // constructor
}

//______________________________________________________________________________
TestRecoModule::~TestRecoModule() {
    // destructor
}

//______________________________________________________________________________
Bool_t TestRecoModule::Init() {
    // Init method: called at the beginning of a run
    cout << "Initing Test Module named " << GetName() << endl;    
    return true;
}

//______________________________________________________________________________
Bool_t TestRecoModule::PreProcess() {
    // called before each event process
    cout << "Pre-processing Test Module named " << GetName() << endl;    
    return true;
}

//______________________________________________________________________________
Bool_t TestRecoModule::Process( RecoEvent* anEvent) {
    // event processing
    cout << "Processing Test Module named " << GetName() << endl;    
    MyData()->Add("aa",2);
    MyData()->Add("aaa",2.);
    vector<Double_t> *v=new vector<Double_t>;
    MyData()->Add("aba",v);

    return true;
}

//______________________________________________________________________________
Bool_t TestRecoModule::PostProcess() {
    // called after processing an event
    cout << "Post Processing Test Module named " << GetName() << endl;    
    return true;
}
//_____________________________________________________________________________
Bool_t TestRecoModule::SaveRootData(RecoRootEvent *fRecoRootEvent) {
     return kTRUE;
}

//______________________________________________________________________________
Bool_t TestRecoModule::Done() {
    // called at the end of each run
    cout << "Ending Test Module named " << GetName() << endl;    
    
    return true;
}

//______________________________________________________________________________
void TestRecoModule::UserMemoryClean() {
    // user cleaning
    vector<Double_t> *v = (vector<Double_t>*)MyData()->GetObj("aba");
    delete v;
    MyData()->RemoveObj("aba");
}

//______________________________________________________________________________
void TestRecoModule::TmpMemoryClean() {
    // user cleaning

    vector<Int_t> dummy;
    dummy.swap(fTmpVector);
}
