// $Id: RecoTrackDirection.cc,v 1.1 2005/01/05 13:08:21 pesce Exp $
// Author: Roberto Pesce 2005/01/04

/*****************************************************************************
 * ESAF: Euso Simulation and Analysis Framework                              *
 *                                                                           *
 *  Id: RecoTrackDirection                                                   *
 *  Package: <packagename>                                                   *
 *  Coordinator: <coordinator>                                               *
 *                                                                           *
 *****************************************************************************/

//_____________________________________________________________________________
//
// RecoTrackDirection
//
// <extensive class description>
//
//   Config file parameters
//   ======================
//
//   <parameter name>: <parameter description>
//   -Valid options: <available options>
//

#include "RecoTrackDirection.hh"

ClassImp(RecoTrackDirection)

//_____________________________________________________________________________
RecoTrackDirection::RecoTrackDirection() {
    //
    // Constructor
    //
    fQuality        = -1;
    fTheta          = -1;
    fPhi            = -1;   
    fErrorTheta     = -1;
    fErrorPhi       = -1;
    fErrorDirection = -1;
    fGraph          = NULL;
}

//_____________________________________________________________________________
RecoTrackDirection::RecoTrackDirection( const RecoTrackDirection& other ) {
    //
    // Copy Constructor
    //
    other.Copy( *this );
}

//_____________________________________________________________________________
RecoTrackDirection::~RecoTrackDirection() {
    //
    // Destructor
    //
    Clear();
}

//_____________________________________________________________________________
void RecoTrackDirection::Clear() {
    //
    // Clear method
    //
    fQuality        = -1;
    fTheta          = -1;
    fPhi            = -1;   
    fErrorTheta     = -1;
    fErrorPhi       = -1;
    fErrorDirection = -1;
    SafeDelete(fGraph);
}

//_____________________________________________________________________________
void RecoTrackDirection::Copy( TObject& other ) const {
    //
    // Copy to new object 
    //
    TObject::Copy( other );

    ((RecoTrackDirection&)other).fQuality        = fQuality;
    ((RecoTrackDirection&)other).fTheta          = fTheta;
    ((RecoTrackDirection&)other).fPhi            = fPhi;
    ((RecoTrackDirection&)other).fErrorTheta     = fErrorTheta;
    ((RecoTrackDirection&)other).fErrorPhi       = fErrorPhi;
    ((RecoTrackDirection&)other).fErrorDirection = fErrorDirection;
    ((RecoTrackDirection&)other).fGraph          = fGraph ? (TMultiGraph*)fGraph->Clone() : NULL;
}

//_____________________________________________________________________________
void RecoTrackDirection::SetCheckInfo( TMultiGraph *t ) {
    //
    // Set the multigraph for check fitting
    //
    SafeDelete(fGraph);
    fGraph = (TMultiGraph*)t->Clone();
}
