// ESAF : Euso Simulation and Analysis Framework
// $Id: ChipTrackSegment.hh,v 1.5 2005/02/16 13:02:47 pesce Exp $
// M. Pallavicini created Oct, 24 2003
// Piece of track found by ChipTrackingTrgEngine
// 
#ifndef __CHIPTRACKSEGMENT_HH_
#define __CHIPTRACKSEGMENT_HH_

#include <iostream>
#include "euso.hh"

class ChipTrackSegment {
public:
    // ctor
    ChipTrackSegment();

    // dtor
    virtual ~ChipTrackSegment();
    
    inline Int_t GetChipUid() const { return fChipUid; }
    inline Int_t GetGtuStart() const { return fGtuStart; }
    inline Int_t GetGtuEnd() const { return fGtuEnd; }
    inline Int_t GetCrossBorder() const { return fCrossBorder; }
    inline Int_t GetTrackLength() const { return fTrackLength; }
    inline Bool_t GetHasHole() const { return fHasHole; }
    inline Bool_t GetTriggered() const { return fTriggered; }
    
    inline void SetChipUid(Int_t v) { fChipUid = v; }
    inline void SetGtuStart(Int_t v) { fGtuStart = v; }
    inline void SetGtuEnd(Int_t v) { fGtuEnd = v; }
    inline void SetCrossBorder(Int_t v) { fCrossBorder = v; }
    inline void SetTrackLength(Int_t v) { fTrackLength = v; }
    inline void SetHasHole(Bool_t v) { fHasHole = v; }
    inline void SetTriggered(Bool_t v) { fTriggered = v; }


private: 
    ClassDef(ChipTrackSegment,0)

    // uid of chip where track occurred
    Int_t fChipUid;        

    // first gtu
    Int_t fGtuStart;

    // last gtu
    Int_t fGtuEnd;

    // true if track is touching the chip border
    Bool_t fCrossBorder;

    // length in number of pixels and gtu
    Int_t fTrackLength;

    // true if the track has a hole
    Bool_t fHasHole;

    // true if the track is a segment of a trigger track
    Bool_t fTriggered;
};
    
ostream& operator << (ostream& os, const ChipTrackSegment& seg); 

#endif  /* __CHIPTRACKSEGMENT_HH_ */

