// ESAF : Euso Simulation and Analysis Framework
// $Id: ChipTrackingTrgEngine2.hh,v 1.7 2005/11/18 13:59:10 pesce Exp $
// R. Pesce created

/*****************************************************************************
 * ESAF: Euso Simulation and Analysis Framework                              *
 *                                                                           *
 *  Id: ChipTrackingTrgEngine2                                               *
 *  Package: Electronics                                                     *
 *  Coordinator: Marco.Pallavicini                                           *
 *                                                                           *
 *****************************************************************************/

#ifndef __CHIPTRACKINGTRGENGINE2_HH_
#define __CHIPTRACKINGTRGENGINE2_HH_

#include "euso.hh"
#include "ChipTrackingTrgEngine1.hh"
#include "ChipTrackSegment.hh"

///////////////////////////////////////////////////////////////////////////////
//                                                                           //
//  ChipTrackingTrgEngine2                                                   //
//                                                                           //
// Tracking trigger built in front end chip logic.                           //
//                                                                           //
// ALGORYTHM:                                                                //
// each chip is capable of finding a track segment of consequtive and        // 
// adjacent pixels.                                                          //
// If the length of a given segment exceeds a threshold, trigger occurs      //
// If not, the macrocell checks if there are 2 segments in nearby front end  //
// chips that summed together exceed the threshold: if this happens, trigger //
// occurs.                                                                   //
//                                                                           //
// Special multiple configuration is read from config file                   //
// A specific trigger word is filled respect to the length of recognized     //
// tracks.                                                                   //
//                                                                           //
///////////////////////////////////////////////////////////////////////////////


class ChipTrackingTrgEngine2 : public ChipTrackingTrgEngine1 {
public:
    // ctor
    ChipTrackingTrgEngine2();
    
    // dtor
    virtual ~ChipTrackingTrgEngine2();

private:
    EsafConfigClass(Electronics,ChipTrackingTrgEngine2);
    ClassDef(ChipTrackingTrgEngine2,0)
};

#endif  /* __CHIPTRACKINGTRGENGINE2_HH_ */

