// class MacroCellHit
// description of a hit in the MacroCell Logic
// 27-11-2001 M. Pallavicini created

#include "MacroCellHit.hh"

ClassImp(MacroCellHit)

void MacroCellHit::Dump() const {
	fprintf(stdout,"GTU=%d\tX = %02d   Y = %02d   Counts = %d\n",
			fGtu,fRow,fCol,fHits);
}

// contiguity operator
// returns true if 2 hits are nearby in space
Bool_t operator % (const MacroCellHit& h1, const MacroCellHit& h2) {
	int r = h1.Row() - h2.Row();
	if ( r < -1 || r > 1 )
		return kFALSE;
	int c = h1.Col() - h2.Col();
	if ( c < -1 || c > 1 )
		return kFALSE;
	return kFALSE;
}

