/* -------------------------------------------------------------------------
 *   EUSO_optF1v1.h
 *
 *   --- definition of EUSO optics etc.
 *        (EPD=2.3m, F1, diffractive feature)
 *
 * $Id: KEUSO_optF1v1.hh,v 1.7 2003/12/15 13:42:32 thea Exp $
 * $Id: KEUSO_optF1v1.hh,v 1.7 2003/12/15 13:42:32 thea Exp $
 * -------------------------------------------------------------------------
 */

#ifndef _EUSO_OPTF1V1_H
#define _EUSO_OPTF1V1_H

#define R_LENS 1250.0
#define K_TOLERANCE 1e-6

#define Rc1 (1/0.00021214714382)        /* 1/cuf */
#define Sz1  0.0+K_TOLERANCE
#define Zc1 (Rc1 + Sz1)

#define Rc2  (1/0.00021214714382)
#define Sz2  (Sz1 + 15.0)               /* 15.0 */
#define Zc2  (Rc2 + Sz2)

#define Zc3  (Sz2 + 376.92335917)       /* 391.92335917*/
#define Zc4  (Zc3 + 0.0)                /* 391.92335917*/
#define Rc3  1127.20776367

#define Rc5  (1/0.000278001688087)
#define Sz5  (Zc4 + 1594.56553209)      /* 1986.48889126 */
#define Zc5  (Sz5 - Rc5)

#define Rc6  (1/0.000278001688087)
#define Sz6  (Sz5 + 15.0)              /*  2001.48889126 */
#define Zc6  (Sz6 - Rc6)

#define S_DATA 15000
#define Acryl_N 71

#define Bg3_N   22

#define R_WALL   1250.0
#define REFRACTIVE_IDX_MEDIA 1.0003   /* air */

#endif
