/* -------------------------------------------------------------------------
 *   trace_optF1v1.h
 *
 *   --- header file for trace_optF1v1.h
 *
 * $Id: Ktrace_optF1v1.hh,v 1.3 2004/06/16 12:17:38 thea Exp $
 * $Id: Ktrace_optF1v1.hh,v 1.3 2004/06/16 12:17:38 thea Exp $
 * -------------------------------------------------------------------------
 */
#ifndef _TRACE_OPTF1V1_H
#define _TRACE_OPTF1V1_H

#include "Rtypes.h"


/* error codes */

#define RT_NO_SPINTERSECTION       -2
#define RT_HIT_SIDE_WALL           -3
#define RT_NO_INTERSECTION1        -4
#define RT_NO_INTERSECTION2        -5
#define RT_OUT_OF_SURFACE1         -6
#define RT_OUT_OF_SURFACE2         -7
#define RT_REFLECTION_DISCARDED    -8
#define RT_NO_REFRACTED_LIGHT      -9
#define RT_REFLECTED_IN_REF       -10
#define RT_ABSORBED               -11
#define RT_OUT_OF_IRIS            -12
#define RT_STRAY_LIGHT            -13

#define RT_REFRACTED                1
#define RT_REFLECTED                2

#define SURFACE0                    0
#define SURFACE1                -1000
#define SURFACE2                -2000
#define SURFACE3                -3000
#define SURFACE4                -4000
#define SURFACE5                -5000
#define SURFACE6                -6000
#define SURFACE7                -7000

#define C0 2997.92458

Int_t Kread_para(char *dir);
Double_t KGet_n_Acryl(Double_t lambda);
Double_t KGet_k_Acryl(Double_t lambda);
Int_t Krefract(Double_t in_ph[3],Double_t nnn[3],Double_t n1,Double_t n2);
Int_t Ktrace(Double_t ph_in[], Double_t ph_out[]);
Int_t KCalSpheVec(Double_t aX, Double_t aY, Double_t aZ, Double_t aCZ, Double_t nnnDIFF[3]);
Int_t KReadSD(char *dirname);
Double_t KCal_D(Double_t r,Int_t s);
Int_t Kdiffract(Int_t ID, Double_t in_phdir[3], 
	     Double_t x3, Double_t y3, Double_t z3, Double_t Zc,
	     Double_t n1, Double_t n2, Double_t wl, Int_t m);

#endif
