// WallInteraction
// $Id: WallInteraction.hh,v 1.6 2005/03/21 17:58:55 thea Exp $
//
// base class providing the interface for wall interactions.
// It also provides a simple implementation using specular reflection.
//  
#ifndef WALLINTERACTION_HH
#define WALLINTERACTION_HH

#include "DetectorPhotonTransporter.hh"
#include "Config.hh"

class WallInteraction: public DetectorPhotonTransporter {
protected:
    Double_t fSpecRefl;
public:
    WallInteraction();
    virtual Photon *Transport(Photon *) const;

    EsafConfigClass(Optics,WallInteraction)

    ClassDef(WallInteraction,0)
};


#endif /* WALLINTERACTION_HH */
