// $Id: erandom.c,v 1.5 2004/10/09 22:33:51 thea Exp $
// A.Thea, created Sep, 24 2004

/*****************************************************************************
 * ESAF: Euso Simulation and Analysis Framework                              *
 *                                                                           *
 *  Id: erandom                                                              *
 *  Package: Externals                                                       *
 *  Coordinator:                                                             *
 *                                                                           *
 *****************************************************************************/

//_____________________________________________________________________________
//
//  Euso Random fortran interface
//
//  Function names follow the convention
//
//  esaf[TRandom method][typeid]_(...)
//

#include "EsafRandom.hh"

extern "C" int    esafbinomial_(int& ntot, double& prob);
extern "C" double esafbreitwigner_(double& mean, double& gamma);
extern "C" double esafexp_( double& tau);
extern "C" double esafgaus_( double& mean, double& sigma);
extern "C" int    esafinteger_( unsigned int& imax);
extern "C" double esaflandau_( double& mpv, double& sigma);
extern "C" int    esafpoisson_( double& mean);
extern "C" double esafpoissond_( double& mean);
extern "C" void   esafrannordbl_( double&, double& );
extern "C" void   esafrannorreal_( float&, float& );
extern "C" double esafrndm_();
extern "C" void   esafrndmarraydbl_( int&, double*);
extern "C" void   esafrndmarrayreal_( int&, float*);
extern "C" double esafuniform_( double& );
extern "C" double esafuniform2_( double&, double&);

//______________________________________________________________________________
int esafbinomial_( int& ntot, double& prob){
    //
    // C wrap for TRandom::Binomial()
    //
    
    return EsafRandom::Get()->Binomial(ntot, prob);
}
//______________________________________________________________________________
double esafbreitwigner_(double& mean, double& gamma){
    //
    // C wrap for TRandom::BreitWigner( Double_t, Double_t )
    //
    
    return EsafRandom::Get()->BreitWigner(mean, gamma);
}

//______________________________________________________________________________
double esafexp_(double& tau) {
    //
    // C wrap for TRandom::Exp( Double_t )
    //

    return EsafRandom::Get()->Exp(tau);
}

//______________________________________________________________________________
double esafgaus_( double& mean, double& sigma) {
    //
    // C wrap for TRandom::Gaus(Double_t, Double_t)
    //
   
    return EsafRandom::Get()->Gaus(mean, sigma); 
}

//______________________________________________________________________________
int esafinteger_( unsigned int& imax){
    //
    // C wrap for TRandom::Integer( Int_t imax )
    //
    
    return EsafRandom::Get()->Integer(imax);
}

//______________________________________________________________________________
double esaflandau_( double& mpv, double& sigma ) {
    //
    // C wrap for TRandom::Landau(Double_t, Double_t)
    //

    return EsafRandom::Get()->Landau(mpv,sigma);
}


//______________________________________________________________________________
int esafpoisson_(double& mean){
    //
    // C wrap for TRandom::Poisson(Double_t mean)
    //
    
    return EsafRandom::Get()->Poisson(mean);
}


//______________________________________________________________________________
double esafpoissond_(double& mean){
    //
    // C wrap for TRandom::PoissonD(Double_t mean)
    //
    
    return EsafRandom::Get()->PoissonD(mean);
}

//______________________________________________________________________________
void esafrannordbl_( double& a, double& b) {
    //
    // C wrap for TRandom::Rannor( Double_t, Double_t )
    //
    
    EsafRandom::Get()->Rannor(a,b);
}

//______________________________________________________________________________
void esafrannorreal_( float& a, float& b) {
    //
    // C wrap for TRandom::Rannor( Float_t, Float_t )
    //
    
    EsafRandom::Get()->Rannor(a,b);
}

//______________________________________________________________________________
double esafrndm_(){
    //
    // C wrap for TRandom::Rndm()
    //
    
    return EsafRandom::Get()->Rndm();
}

//______________________________________________________________________________
void esafrndmarraydbl_( int& n, double* array) {
    //
    // C wrap for TRandom::RndmArray(Int_t, Double_t*)
    //

    EsafRandom::Get()->RndmArray(n, array);

//    Printf("RndmArrayDbl");
//    for(Int_t i(0); i<*n; i++)
//        Printf("%d   %g", i, array[i]);
}

//______________________________________________________________________________
void esafrndmarrayreal_( int& n, float* array) {
    //
    // C wrap for TRandom::RndmArray(Int_t, Float_t*)
    //

    EsafRandom::Get()->RndmArray(n, array);

//    Printf("RndmArrayReal");
//    for(Int_t i(0); i<*n; i++)
//        Printf("%d   %g", i, array[i]);
}

//______________________________________________________________________________
double esafuniform_( double& x ) {
    //
    // C wrap for TRandom::Uniform(Double_t)
    //

    return EsafRandom::Get()->Uniform( x );
}

//______________________________________________________________________________
double esafuniform2_( double& x1, double& x2) {
    //
    // C wrap for TRandom::Uniform(Double_t, Double_t)
    //

    return EsafRandom::Get()->Uniform(x1,x2);
}

