*
*     ... THIS FUNCTION RETURNS THE MIE TRANSITION FACTOR   ...
*     ... IN THE ATMOSPHERE BETWEEN THE POINTS WITH         ...
*     ... RADIUS_VECTORS R(3) AND ISS
*     ... DATE: 09.06.2002
*     ... AUTHOR: D.V. NAUMOV
*
      REAL FUNCTION MIE_R_ISS(R)
      IMPLICIT NONE
#include "detector.inc"
#include "event.inc"
*     ... EXTERNAL CALLS  ...
      REAL HXY
*     ... INPUT VARIABLES ...
      REAL R(3)
*     ... LOCAL VARIABLES ...
      INTEGER i_aux_hbk, ID
      REAL PI,HALF_PI,MIE_R
      REAL RTOISS(3), H_R,THETA_R, DEPTH_R, SCALAR_R
      REAL SCALAR_ISS_RTOISS,SCALAR_ISS,SCALAR_RTOISS,cos_R_ISS
      SAVE i_aux_hbk
      DATA i_aux_hbk/0/
      LOGICAL HEXIST
*
      PI      = ACOS(-1.)
      HALF_PI = PI/2
      ID = 10000
*     
      CALL VECTORLIB(3,'-',ISS,R,RTOISS)
      CALL VECTORDOT(3,ISS,RTOISS,SCALAR_ISS_RTOISS)
      CALL VECTORDOT(3,ISS,ISS,SCALAR_ISS)
      CALL VECTORDOT(3,RTOISS,RTOISS,SCALAR_RTOISS)
      CALL VECTORDOT(3,R,R,SCALAR_R)
      IF(SCALAR_ISS*SCALAR_RTOISS.NE.0.) THEN
         cos_R_ISS  = SCALAR_ISS_RTOISS/SQRT(SCALAR_ISS*SCALAR_RTOISS)
      ELSE
         cos_R_ISS  = 0.
      ENDIF
      THETA_R = ACOS(cos_R_ISS)
      H_R     = SQRT(SCALAR_R) - R_EARTH
*     ... COMPUTE MIE FACTORS BETWEEN R AND INFINITY ...
      IF(THETA_R.LE.HALF_PI) THEN
         MIE_R = HXY(ID,THETA_R,H_R)
      ELSE
         MIE_R = 0.
      ENDIF
*     ... COMPUTE MIE FACTOR BETWEEN R1 AND R2 ...
         MIE_R_ISS = EXP(-MIE_R)
         
 1000 CONTINUE
      END
