      SUBROUTINE SPECTRUM_INIT
#include "event.inc"
#include "shower.inc"
#include "detector.inc"
      CHARACTER*22 CHTAG(1)/'HILLAS PARAMETRIZATION'/

      Emin = 1.e0               ! MeV
      Emax = 1.e4               ! MeV
      Ne = 10000
      Ns = 20
      Smin = 0.1
      Smax = 2.0
      step_e = (Emax-Emin)/(Ne-1)
      step_s = (Smax-Smin)/(Ns-1)
      Nint = Ne*Ns
      i_portion = Nint/10
*
      CALL BOOK_HISTOS('DUMP')
      IF(SPEC.EQ.1) THEN
*
         WRITE(6,*) ' '
         WRITE(6,98)
*
         DO k = 1, 1
            l = 0 
            ID = 1000*k
            WRITE(6,99) CHTAG(k)
            DO i = 1, Ne
               e = Emin + (i-1)*step_e
               DO j = 1, Ns
                  s = Smin + (j-1)*step_s
                  l = l + 1
                  CALL HFILL(ID,s,e,ENERGY_THRESHOLD(s,e))
                  CALL HFILL(ID+1,s,e,ENERGY_SPECTRUM(s,e))
                  fraction_integral = 
     +                 ENERGY_SPECTRUM_INTEGRAL(s,e)
                  CALL HFILL(ID+2,s,e,fraction_integral)
                  ntmp = l/i_portion
                  ntmp = l - ntmp*i_portion
                  IF(ntmp.EQ.0) WRITE(6,100)
               ENDDO
            ENDDO
            WRITE(6,101)
            WRITE(6,*) ' '
         ENDDO

*     ... NOW WRITE THE FRACTION OF ELECTRONS WITH 
*     ... THE ENERGY ABOVE THE CHERENKOV THRESHOLD
         
         SPEC = 0
         DO k = 1, 1
            ID = 1000*k
            DO i = 1, Ne
               e = Emin + (i-1)*step_e
               DO j = 1, Ns
                  s = Smin + (j-1)*step_s
                  ch_threshold = CHERENKOV_THRESHOLD(s,e)
                  CALL HFILL(ID+3,s,e,ch_threshold)
                 ENDDO
            ENDDO 
         ENDDO
         SPEC = 1
      ENDIF
 98   FORMAT(1x,'COMPUTING THE ENERGY DISTRIBUTION INTEGRALS: ')
 99   FORMAT($,1x,'FOR ',A,11x,'(breath deeply)')
 100  FORMAT($,1x,'.')
 101  FORMAT($,1x,'[done]')
      END
