      SUBROUTINE ACCEPTANCE(Lmax)
      IMPLICIT NONE
#include "detector.inc"
#include "event.inc"
#include "cwntvars.inc"
#include "constants.inc"
      INTEGER i_z_dist
      SAVE i_z_dist,zmin
      DATA i_z_dist/0/
      REAL dir_unit(3),SCALAR11,SCALAR12,DISCR,z_ground,zmin
      REAL Lmax,L1,L2
      IF(i_z_dist.EQ.0) THEN
        zmin = ISS(3)*SIN(FOV)**2 + COS(FOV)**2*
     +       SQRT(R_EARTH**2-TAN(FOV)**2*(ISS(3)**2-R_EARTH**2))
        i_z_dist = 1
      ENDIF

*     ... DECIDE WHAT KIND OF THE SHOWER IT IS :
*     ... HITTING THE GROUND SURFACE: 
*     ... INSIDE  SPACE TELESCOPE FOV  (1)
*     ... OUTSIDE SPACE TELESCOPE FOV  (2)
*     ... NOT HITTING THE EARTH AT ALL (3)
*
      dir_unit(1) = -SIN(THETA/180.*PI)*COS(PHI/180.*PI)
      dir_unit(2) = -SIN(THETA/180.*PI)*SIN(PHI/180.*PI)
      dir_unit(3) = -COS(THETA/180.*PI)
      CALL VECTORDOT(3,RINT,RINT,SCALAR11)
      CALL VECTORDOT(3,RINT,dir_unit,SCALAR12)
      DISCR = SCALAR12**2 - SCALAR11 + (R_EARTH)**2
      IF(DISCR.LT.0.) THEN
*     ... NO SOLUTION --> TYPE(3)
        ACCEPTANCE_TYPE = 3.
        XG = 10000.
        YG = 10000.
        ZG = 10000.
        Lmax = 10000.
      ELSE
        L1 = -SCALAR12 + SQRT(DISCR)
        L2 = -SCALAR12 - SQRT(DISCR)
        IF(L1.GT.0..AND.L2.GT.0.) THEN
*       ... CHOOSE MINIMAL L ...
          Lmax = MIN(L1,L2)
        ELSEIF(L1.LT.0..AND.L2.LT.0.) THEN
*       ... NO SOLUTION --> TYPE(3)
          ACCEPTANCE_TYPE = 3.
          XG = 10000.
          YG = 10000.
          ZG = 10000.
          Lmax = 10000.
          RETURN
        ELSEIF(L1*L2.LT.0.) THEN
          WRITE(6,*) 'RINT GENERATED INSIDE THE EARTH'
          STOP
        ENDIF
        z_ground = RINT(3) - Lmax*COS(THETA/180.*PI)
        XG = RINT(1) - Lmax*SIN(THETA/180.*PI)*COS(PHI/180.*PI)
        YG = RINT(2) - Lmax*SIN(THETA/180.*PI)*SIN(PHI/180.*PI)
        ZG = z_ground
        IF(z_ground.GE.zmin) THEN
          ACCEPTANCE_TYPE = 1.
        ELSE
          ACCEPTANCE_TYPE = 2.
        ENDIF
      ENDIF
      END
