// ESAF : Euso Simulation and Analysis Framework
// $Id: EventGenerator.hh,v 1.10 2006/03/20 21:51:35 thea Exp $
// Alessandro Thea created Nov, 20 2003

#ifndef __EVENTGENERATOR_HH_
#define __EVENTGENERATOR_HH_

#include "euso.hh"
#include "EsafConfigurable.hh"
#include "Rtypes.h"

class PhysicsData;
class MCTruth;


class EventGenerator: public EsafConfigurable {
public:
    // dtor
    virtual ~EventGenerator();

    // get a new event
    virtual PhysicsData *Get() = 0;

    // get pointer to MonteCarlo Truth
    virtual MCTruth *GetTruth() = 0;
    
    // get ready for next event
    virtual void Reset() = 0;

    inline const string& GetName() const { return fName; }

    // TODO: release all the memory hold in buffers. 
    virtual Bool_t ClearMemory() { return kTRUE; } 
    EsafConfigClass(Generators, EventGenerator)

protected:
    // ctor
    EventGenerator( const char* );

private:
    string fName;

    ClassDef(EventGenerator,0)
};


#endif  /* __EVENTGENERATOR_HH_ */

