// ESAF : Euso Simulation and Analysis Framework
// $Id: KakimotoFluoCalculator.hh,v 1.10 2005/01/24 09:23:59 moreggia Exp $
// Anne Stutz created Mar, 23 2004

#ifndef __KAKIMOTOFLUOCALCULATOR_HH_
#define __KAKIMOTOFLUOCALCULATOR_HH_

#include "euso.hh"
#include "FluoCalculator.hh"
#include <TF12.h>
#include <TH1F.h>

class KakimotoFluoCalculator : public FluoCalculator{
public:
    // ctor
    KakimotoFluoCalculator();

    // dtor
    virtual ~KakimotoFluoCalculator();

    // get ready for next event
    virtual void Reset() {}

    // get the wavelenght spectrum of the fluorescence emission
    virtual Double_t GetFluoYield(const Double_t alt, const Double_t energy, EsafSpectrum* FluoSpectrum=0) const;

    // get the wavelenght spectrum of the fluorescence emission for an energy distribution
    virtual Double_t GetFluoYield(const Double_t alt, TF12* EnergyDistribution=0, EsafSpectrum* FluoSpectrum=0) const;
    
    // get the wavelenght spectrum of the fluorescence emission for an energy distribution
    virtual Double_t GetFluoYieldHisto(const Double_t alt, const TH1F* EnergyDistribution=0, EsafSpectrum* FluoSpectrum=0) const;

    // get the dEdX of an electron of energy KF_energy
    Double_t GetdEdX(const Double_t energy) const;

    // plot yield
    void PlotYield();

private:

    ClassDef(KakimotoFluoCalculator,0)
};

#endif  /* __KAKIMOTOFLUOCALCULATOR_HH_ */

