// ESAF : Euso Simulation and Analysis Framework
// $Id: FileUnisimLightToEuso.hh,v 1.4 2006/03/20 21:51:35 thea Exp $
// M. Pallavicini created Jul,  2 2002

#ifndef __FILEUNISIMLIGHTTOEUSO_HH_
#define __FILEUNISIMLIGHTTOEUSO_HH_

#include "euso.hh"
#include "LightToEuso.hh"
#include "UnisimPhotonsOnPupil.hh"
#include "Config.hh"
#include "EEvent.hh"
#include "MCTruth.hh"

class PhysicsData;

class FileUnisimLightToEuso : public LightToEuso {
public:
    // ctor
    FileUnisimLightToEuso();

    // dtor
    virtual ~FileUnisimLightToEuso();

    // returns the list of photons for the pupil
    virtual PhotonsOnPupil *Get(const DetectorGeometry*);

    // next functions not meaningful in this case
    virtual void Configure() { return; }
    virtual MCTruth* GetTruth();
    virtual PhysicsData* GetPhysics() { return NULL; }

    virtual void ReplaceInputFile( const char* );

    virtual Bool_t ClearMemory();

    EsafConfigClass(LightToEuso,FileUnisimLightToEuso)

private:
    UnisimPhotonsOnPupil fPhotons;
    string fName;
    FILE* fP;
    MCTruth* fTruth;
    int fFirstEvent;              // this is the first event to read. All previous will be skipped
    int fCurrentEvent;            // this is the current event to read.
    void Open();
  
    ClassDef(FileUnisimLightToEuso,0)
};

#endif  /* __FILEUNISIMLIGHTTOEUSO_HH_ */

