// ESAF : Euso Simulation and Analysis Framework
// $Id: LightToEuso.cc,v 1.2 2005/04/18 11:34:33 moreggia Exp $
// Marco Pallavicini created Mar, 13 2002

#include "LightToEuso.hh"
#include "EventGenerator.hh"
#include "RadiativeTransfer.hh"
#include "LightSource.hh"
#include "Atmosphere.hh"

ClassImp(LightToEuso)

//______________________________________________________________________________
LightToEuso::LightToEuso(const string& name) : EsafConfigurable(), EsafMsgSource(), fGenerator(0), 
                                               fLight(0), fRadiative(0) {
    //
    // ctor
    //
    fName = name;
}

//______________________________________________________________________________
LightToEuso::~LightToEuso() {
    //
    // dtor
    //
    SafeDelete(fGenerator);
    SafeDelete(fLight);
    SafeDelete(fRadiative);
}

//______________________________________________________________________________
void LightToEuso::Reset() {
    //
    // get ready for next event. Reset method of every imbricated object is called.
    //
    Atmosphere::Get()->ResetClouds();
    if(fGenerator) fGenerator->Reset();
    if(fLight) fLight->Reset();
    if(fRadiative) fRadiative->Reset(); 
}
