#!/usr/bin/perl
# $Id: CreateNewLib.pl,v 1.4 2004/09/28 08:17:29 pallas Exp $
# simple tool to create an empty library structure
# A. Thea.
#

use Getopt::Std;
getopt('nus');

use POSIX qw(strftime);
$now_string = strftime "%b, %e %Y", gmtime;


$shared = $opt_s;
$libname = $opt_n;

$libname or die "CreateLibClass: no name defined\n\t usage: CreateNewLib.pl -n name [-s standalone] [-u username]";

$uid = $<;
$user = (getpwuid($uid))[6];
$user=~s/,.*$//;

if ($opt_u) {
  $user = $opt_u;
}

$aa = $classname;
$aa=~y/[a-z]/[A-Z]/;


print "creating $libname directory\n";
mkdir($libname,0755);
chdir($libname);

print "creating include directory\n";
mkdir("include",0755);

print "creating src directory\n";
mkdir("src",0755);

print "creating GNUmakefile\n";
open(MK,">GNUmakefile");

if (!$shared) {
print MK <<pippo;
# GNUmakefile for $libname
# \$Id\$
# Author: $user $now_string


#############################################################################
# ESAF: Euso Simulation and Analysis Framework                              #
#                                                                           #
#  Id: $libname                                                             #
#  Package: <packagename>                                                   #
#  Coordinator: <coordinator>                                               #
#                                                                           #
#############################################################################

PACKAGENAME := $libname

ifndef ESAFINSTALL
ESAFINSTALL = ../../../..#FIXME: ESAFINSTALL relative path
endif

ESAFPACKAGES = \$(ESAFINSTALL)/packages

# Config parameters
include \$(ESAFINSTALL)/packages/config.gmk

# Include paths needed for rootcint dictionary generation
INCLUDES += -I \$(ESAFPACKAGES)/common/base/include
INCLUDES += -DUSE_VISUALIZATION

# headers and settings needed for the local library compilation
CXXFLAGS += \$(INCLUDES)

include \$(ESAFINSTALL)/packages/makeso.gmk

pippo
} else {

print MK <<pippo;
# GNUmakefile for $libname
# \$Id\$
# $user created $now_string
#

name := $libname
nameso := $shared

LIBTARGET := lib\$(nameso).so

ifndef ESAFINSTALL
ESAFINSTALL = ../../../..#FIXME: ESAFINSTALL relative path
endif

ESAFPACKAGES = \$(ESAFINSTALL)/packages

include \$(ESAFINSTALL)/packages/config.gmk

CXXFLAGS += -I \$(ESAFPACKAGES)/common/base/include
CXXFLAGS += -DUSE_VISUALIZATION

linkdef := \$(nameso)LinkDef#FIXME: this is default Dict name
dict := \$(nameso)Dict#FIXME: this is default Dict name
libclasses :=#FIXME: Insert here the name of the files of the shared lib.

dicts := \$(patsubst %,%.cc,\$(dict))
dicth := \$(patsubst %,%.h,\$(dict))
libheaders := \$(patsubst %,include/%.hh,\$(libclasses) \$(linkdef))
libsources := \$(patsubst %,src/%.cc,\$(libclasses)) \$(dicts)

include \$(ESAFINSTALL)/packages/common.gmk
\$(LIBDIR)/\$(LIBTARGET): \$(LIBDIR)/lib\$(name).a
	\@echo Building \$(nameso) dictionary...
	\@rootcint -f \$(dicts) -c \$(libheaders)
	\@echo Building \$(LIBTARGET)...
	\$(CXX) --shared \$(CXXFLAGS) \$(dicts) -L\$(LIBDIR) -l\$(name) -o \$(LIBDIR)/\$(LIBTARGET)
	\@echo Cleaning temporary files...
	\@rm -r \$(dicts) \$(dicth) 


rootlib: \$(LIBDIR)/\$(LIBTARGET)

pippo
}
