{
    enum ERootMode { kUser, kDevelop };
    const ERootMode gMode = kDevelop;



    TString appName = gROOT->GetName();

    // root specific settings
    if ( appName == "Rint" ) {
        TString gEusoDirectory = gSystem->WorkingDirectory();
        TString gEusoMacrosDirectory = gEusoDirectory + "/macros";
        TString gEusoOutputDirectory = gEusoDirectory + "/output";

        cout << "Adding additional paths:" << endl;
        // set macro path to include esaf macros
        TString macropath = gROOT->GetMacroPath();
        if (!macropath.Contains("$PWD/macros")) {
            macropath += ":";
            macropath += gSystem->ExpandPathName("$PWD/macros");
            gROOT->SetMacroPath(macropath);
            cout << "   esaf/macros" << endl; 
        }
  
        if ( gMode == kUser ) {
            
            Bool_t first = kTRUE;
            
            cout << "Loading additional libraries:\n   " << flush;
            // check to see if the event class is in the dictionary
            // if it is not load the definition in libEvent.so
            if (!TClassTable::GetDict("TVector3")) {
                if ( first )  first = kFALSE; else  cout << ", ";
                cout << "libPhysics" << flush;
                gSystem->Load("libPhysics");
            }
            if (!TClassTable::GetDict("TGeoManager")) {
                if ( first )  first = kFALSE; else  cout << ", ";
                cout << "libGeom" << flush;
                gSystem->Load("libGeom");
            }
            if (!TClassTable::GetDict("TGWindow")) {
                if ( first )  first = kFALSE; else  cout << ", ";
                cout << "libGui" << flush;
                gSystem->Load("libGui");
            }
            if (!TClassTable::GetDict("TGedFrame")) {
                if ( first )  first = kFALSE; else  cout << ", ";
                cout << "libGed" << flush;
                gSystem->Load("libGed");
            }

            if (!TClassTable::GetDict("EEvent")) {
                if ( first )  first = kFALSE; else  cout << ", ";
                cout << "libSimuEvent" << flush;
                gSystem->Load("libSimuEvent");
            }

            if (!TClassTable::GetDict("EAnimator")) {
                if ( first )  first = kFALSE; else  cout << ", ";
                cout << "libEventViewer" << flush;
                gSystem->Load("libEventViewer");
            }

            if (!TClassTable::GetDict("")) {
                if ( first )  first = kFALSE; else  cout << ", ";
                cout << "libRecoRootEvent" << flush;
                gSystem->Load("libRecoRootEvent");
			}

            gROOT->ProcessLine(".include packages/common/root/include");
            gROOT->ProcessLine(".include packages/common/root/eventviewer");
            cout << endl;
        } else {
            cout << "ROOT running in ESAF Developer's mode" << endl;
            gROOT->ProcessLine(".include include");

            gROOT->ProcessLine(".x doc/loadlibs.C"); 
        }
    }
} 
